#ifndef BatchLab_FindAllocator_h
#define BatchLab_FindAllocator_h

#include <BatchLab/Core/HistogramAllocator.h>

#include <Slash/Core/ISession.h>
#include <Lib/Manager.h>
#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/Cast.h>

namespace BatchLab {

BatchLab::HistogramAllocator* histogramAllocator(Slash::Core::ISession& aSession) {
  // Look for an HistogramAllocator, pick the first found :
  std::vector<std::string> facs;
 {unsigned int number = aSession.numberOfManagers();
  for(unsigned int index=0;index<number;index++) {
    const Slash::Core::IManager* mgr = aSession.manager(index);
    if(Lib_ConstCast(*mgr,BatchLab::HistogramAllocator)) {
      facs.push_back(mgr->name());
    }
  }}
  if(!facs.size()) {
    Lib::Out out(aSession.printer());
    out << "BatchLab::histogramAllocator :" 
        << " can't find a BatchLab::HistogramAllocator." 
        << Lib::endl;
    return 0;
  }
  BatchLab::HistogramAllocator* allocator = 
    Lib_findManager(aSession,facs[0],BatchLab::HistogramAllocator);
  if(!allocator) {
    Lib::Out out(aSession.printer());
    out << "BatchLab::histogramAllocator :" 
        << " can't find a BatchLab::HistogramAllocator (2)." 
        << Lib::endl;
    return 0;
  }
  if(aSession.verboseLevel()) {
    Lib::Out out(aSession.printer());
    out << "BatchLab::histogramAllocator :" 
        << " HistogramAllocator is " << Lib::sout(facs[0]) 
        << Lib::endl;
  }
  return allocator;
}

}

#endif
