#ifndef BatchLab_FS_Manager_h
#define BatchLab_FS_Manager_h

//Inheritance :
#include <Slash/Core/IManager.h>
#include <Slash/Store/IStoreManager.h>

#include <vector>

namespace Slash {namespace Core {class ISession;}}
namespace Slash {namespace Store {class IObject;}}

namespace BatchLab {

namespace FS {

class Manager 
:public virtual Slash::Core::IManager
,public virtual Slash::Store::IStoreManager 
{
public: //Slash::Core::IManager
  virtual std::string name() const;
  virtual void* cast(const std::string&) const;
public: //Slash::Store::IStoreManager
  virtual Slash::Store::ITree* createTree(const std::string&,
                                  bool = false, 
                                  bool = false, 
                                  const std::string& = "" );
  virtual Slash::Store::IObject* createObject(Slash::Store::ITree&,
                                  const std::string&,
                                  const std::string&,
                                  const std::string&,
                                  const std::string&,
 			          const std::vector<std::string>&,
                                  const std::string& = "");
  virtual Slash::Store::IObject* createObject(Slash::Store::ITree&,
                                  const std::string&,
                                  const std::string&,
                                  const std::string&,
                                  const std::string&,
   			          const std::vector<Slash::Store::IStoreManager::Range>&,
                                  const std::string& = "");
public:
  Manager(Slash::Core::ISession&);
  virtual ~Manager();
private:
  std::string fName;
  Slash::Core::ISession& fSession;
};

} //FS

} //BatchLab

#endif


