#ifndef G4LabTemplateFour_Analysis_h
#define G4LabTemplateFour_Analysis_h

#include <string>

namespace G4LabTemplateFour {
  class Detector;
}

namespace AIDA {
  class IAnalysisFactory;
  class ITree;
  class IHistogram1D;
  class IHistogram2D;
  class IProfile1D;
  class ITuple;
}

namespace G4LabTemplateFour {

class Analysis {
public:
  Analysis(AIDA::IAnalysisFactory&,Detector&,
           const std::string& fileName = "");
  virtual ~Analysis();
private:
  AIDA::IAnalysisFactory& fAIDA;
  AIDA::ITree* fTree;
public:
  AIDA::ITuple* f_run;
  AIDA::IHistogram1D* f_z;
  AIDA::IHistogram1D* f_z_dE;
  AIDA::IHistogram1D* f_r;
  AIDA::IHistogram1D* f_r_dE;
  AIDA::IHistogram2D* f_z_dE_r_dE;
  AIDA::ITuple* f_tuple;
  double f_dE;
};

}

#endif
