#ifndef G4LabTemplateOne_CellHit_h
#define G4LabTemplateOne_CellHit_h

//Inheritance :
#include <G4VHit.hh>

#include <G4Transform3D.hh>

class G4LogicalVolume;

namespace G4LabTemplateOne {
  
class CellHit : public G4VHit {
public: //G4VHit
  virtual void Draw();
  virtual void Print();
  virtual const std::map<G4String,G4AttDef>* GetAttDefs() const;
  virtual std::vector<G4AttValue>* CreateAttValues() const;     
public:    
  void *operator new(size_t);
  void operator delete(void*);    
  CellHit();
  CellHit(const CellHit&);
  virtual ~CellHit();
  const CellHit& operator=(const CellHit&);
  G4int operator==(const CellHit&) const;    
public:
  void SetEnergy(G4double);
  G4double GetEnergy() const;
  void SetLV(G4LogicalVolume*);
  void SetTSF(const G4Transform3D&);
private:
  G4LogicalVolume* fLV;
  G4Transform3D fTSF;
  G4double fEnergy;
};
  
}

#endif
