#ifndef Lib_RelationManager_h
#define Lib_RelationManager_h

// Inheritance :
#include <Slash/Core/IRelation.h>
#include <Slash/Core/IManager.h>
#include <Slash/Core/IRelationManager.h>

#include <list>

namespace Slash {namespace Core {class ISession;}}

namespace Lib {

class RelationManager
:public virtual Slash::Core::IManager 
,public virtual Slash::Core::IRelationManager 
{
public: //Slash::Core::IManager
  virtual std::string name() const;
  virtual void* cast(const std::string&) const;
public: //IRelationManager
  virtual void add(Slash::Core::IRelation*);
  virtual void visit(Slash::Core::IRelationVisitor&);
  virtual void remove(Slash::Core::IRelationVisitor&);
  virtual void removeWith(void*);
  virtual bool isValid(const Slash::Core::IRelation&) const;
public:
  RelationManager(Slash::Core::ISession&);
  virtual ~RelationManager();
private:
  Slash::Core::ISession& fSession;
  std::string fName;
  std::list<Slash::Core::IRelation*> fList;
};

}

#endif




