#
# Add image "regions" (done with the HEPVis SoImageRegion nodekit).
# One with the LAL logi, the other one with the LHCb logo.
#
# This script could be executed on an OnX Python callback ;
# for example on a MenuItem with :
#    <activate exec="Python">import OnX;OnX.x('OnX_exa_images')</activate>
# or from the OnX UI Python prompt with :
#   Python> import OnX_exa_images
# or from the python shell with :
#       OS> <setup OnX>
#       OS> <start Python>
#       >>> import OnX_exa_images
#

import OnX
import OnX as Lib

import CoinPython as Inventor

import HEPVis

onx_main = None
if OnX.session() == None:  # Start from scratch (for exa from the Python shell)
  import OnX
  onx_main = OnX.run(0,0) # Create the ONXFILE UI but do not ui.steer.
  ui = OnX.session().ui()
  ui.currentPage().currentRegion().clear()  # To clear the OnX banner.
 
ui = OnX.session().ui()

soPage = ui.currentPage()
soPage.titleVisible.setValue(Inventor.FALSE)
soPage.currentRegion().color.setValue(Inventor.SbColor(0.4,0.4,0.4))

# LAL logo :
soRegion = soPage.createRegion(Inventor.SbString("SoImageRegion"),0.8,0.01,0.1,0.1)
soViewportRegion = soRegion.getViewportRegion()
soViewportRegion.horizontalBorder.setValue(2)
soViewportRegion.verticalBorder.setValue(2)
soViewportRegion.borderColor.setValue(Inventor.SbColor(0,1,0))

file = Lib.fmanip_name("$ONXROOT/scripts/images/logo_LAL.gif")
soImageRegion = soRegion.cast_SoImageRegion()
soImageRegion.getImage().fileName.setValue(file)

# LHCb logo :
soRegion = soPage.createRegion(Inventor.SbString("SoImageRegion"),0.01,0.75,0.1,0.1)
soViewportRegion = soRegion.getViewportRegion()
soViewportRegion.horizontalBorder.setValue(2)
soViewportRegion.verticalBorder.setValue(2)
soViewportRegion.borderColor.setValue(Inventor.SbColor(0,1,0))
file = Lib.fmanip_name("$ONXROOT/scripts/images/logo_LHCb.gif")
soImageRegion = soRegion.cast_SoImageRegion()
soImageRegion.getImage().fileName.setValue(file)

soPage.highlightRegion(soPage.getRootRegion(0))

del file
del soImageRegion
del soViewportRegion
del soRegion
del soPage

if onx_main != None:
  ui.show()
  ui.steer()
  del onx_main
