#ifndef OnX_Action_h
#define OnX_Action_h 

// Inheritance :
#include <Slash/Core/IAction.h>

#include <OnX/Core/CallbackData.h>

namespace Slash {namespace UI {class IUI;}}
namespace Slash {namespace UI {class IWidget;}}
class IIB;

namespace OnX {

class Action : public virtual Slash::Core::IAction {
public: //Slash::Core::IAction
  virtual void* cast(const std::string&) const;
  virtual std::string name() const;
  virtual std::string execute(const std::vector<std::string>&);
public:
  typedef void* NativeWidget;
public:
  Action(Slash::UI::IUI&,
         Slash::UI::IWidget*,
         NativeWidget,
         const std::string&,int,
         const std::string&,const std::string&);
  Action(Slash::UI::IUI&,
         const std::string&,int,
         const std::string&,const std::string&,
         const CallbackData&);
  Action(const Action&);
  Action& operator=(const Action&);
  bool equal(const Action&);
  virtual ~Action();
  bool isBackground();
  void setBackground(bool); 
  Slash::UI::IWidget* widget() const;
  NativeWidget nativeWidget() const;
  void setID(int);
  int getID() const;
  Slash::UI::IUI& ui() const;
  const CallbackData& callbackData() const;
  const std::string& script() const;
  void setInterpreter(const std::string&);
  void setScript(const std::string&);
private:
  Slash::UI::IUI& fUI;
  Slash::UI::IWidget* fWidget;
  NativeWidget fNativeWidget;
  std::string fName;
  int fID;
  std::string fInterpreter;
  std::string fScript;
  CallbackData fCallbackData;
};

}

#endif


