#
#  From the Python shell :
#   OS> <setup OnXLab>
#   OS> <start python>
#  (>>> import AIDA)
#   >>> import OnXLab_exa_aida_8
#

#
# ASCII file.
#

import AIDA

aida = AIDA.createAnalysisFactory()

treeFactory = aida.createTreeFactory()
memoryTree = treeFactory.create()

file = '$ONXLABROOT/examples/data/data.ascii'
asciiTree = treeFactory.create(file,'ASCII',1,0)
del treeFactory

tupleFactory = aida.createTupleFactory(asciiTree)
tuple = tupleFactory.create('tuple','tuple','v1 v2')
evaluator = tupleFactory.createEvaluator('v1')
filter = tupleFactory.createFilter('')
del tupleFactory

#debug tuple.dump()

histogramFactory = aida.createHistogramFactory(memoryTree)
h = histogramFactory.createHistogram1D('h','tuple/v1',10,1,11)
del histogramFactory

tuple.project(h,evaluator,filter)

plotterFactory = aida.createPlotterFactory()
plotter = plotterFactory.create('')
del plotterFactory
plotter.createRegions(1,1,0)
plotter.setTitle('Ascii tuple example')
plotter.currentRegion().plot(h)

plotter.show()
plotter.interact()

del plotter

del h
del evaluator
del filter
del tuple
del asciiTree

del memoryTree
del aida
