import AIDA

aida = AIDA.createAnalysisFactory()

treeFactory = aida.createTreeFactory()
memoryTree = treeFactory.create()
del treeFactory

plotterFactory = aida.createPlotterFactory()
functionFactory = aida.createFunctionFactory(memoryTree)
histogramFactory = aida.createHistogramFactory(memoryTree)

# Get current plotter :
plotter = plotterFactory.create('')

plotter.createRegions(1,2,0)
plotter.setTitle('Function 2D')

import math

# Filling a function with arrays of doubles :
params = []
# Grid of dimension 2 :
params.append(2)
NX = 50
params.append(NX)
NY = 50
params.append(NY)
for I in range(0,NX):
 x = -10 + 0.399 * I
 params.append(x)
for J in range(0,NY):
 y = -10 + 0.399 * J
 params.append(y)
C  = 0
for J in range(0,NY):
 y = -10 + 0.399 * J
 for I in range(0,NX):
  x = -10 + 0.399 * I
  params.append((math.sin(x)/x) * (math.sin(y)/y))
  C = C + 1

# Then give 1 + 1 + 1 + NX + NY + NX * NY values for parameters.

#FIXME : Grid2D is not an AIDA agreed function.
function = functionFactory.createFunctionByName('function2D','Grid2D')
#FIXME function.setTitle('sin(x)/x) * (sin(y)/y)')
function.setParameters(params)
region = plotter.currentRegion()
region.plot(function)

region.setParameter('plotter.xAxisAutomated','FALSE')
region.setParameter('plotter.xAxisMinimum','-10')
region.setParameter('plotter.xAxisMaximum','10')

region.setParameter('plotter.yAxisAutomated','FALSE')
region.setParameter('plotter.yAxisMinimum','-10')
region.setParameter('plotter.yAxisMaximum','10')

region.setParameter('plotter.functionStyle[0].color','0 1 0')
region.setParameter('plotter.functionStyle[0].painting','BY_VALUE')
region.setParameter('plotter.colorMapping','black -0.2 cyan 0. green 0.1 orange 0.4 red')

# Convertion to a Cloud2D :
cloud = function.convertToCloud(histogramFactory,"cloudFromFunction","Function to Cloud convertion") # OnXLab SWIG extension.

if cloud !=None :
 plotter.next().plot(cloud)

plotter.show()
plotter.interact()

del cloud
del plotter
del params
del function
del functionFactory
del histogramFactory
del plotterFactory
del aida
