//  Mai/2007 : G.Barrand : creation.

#ifndef SoSDL_SoSDL_h
#define SoSDL_SoSDL_h 

#include <SDL.h>

#ifdef WIN32
//  There is a clash with int typedefs (int8_t,...) found in :
//    CoinGL/include/Inventor/system/inttypes_win32.h
// and :
//    SDL/1.2.11/include/SDL_config_win32.h
#define COIN_NO_INT_TYPEDEFS
#endif

#include <Inventor/SbBasic.h>
#include <Inventor/SbString.h>

#include <vector>

class SoSDL_Viewer;
class SoSDL_AudioSample;

class SoSDL_Widget {
public:
  SoSDL_Widget();
  virtual~ SoSDL_Widget();
  void setViewer(SoSDL_Viewer*); //FIXME
  SoSDL_Viewer* getViewer() const; //FIXME
private:  
  SoSDL_Viewer* fViewer; //FIXME
};

// Have similar APU than other SoGui (SoXt, SoQt, etc...).

class SoSDL {
public:
  //static SbBool init();
  static SoSDL_Widget* init(int video_width,int video_height,Uint32 flags);
  static void show(SoSDL_Widget*);
  static void mainLoop();
  //
  static void clear();
  static SDL_Surface* screen();
  static void playAudioFile(const SbString&);
  static void clearAudio();
  static bool isShiftDown();
  static void setViewerRender();
  static void toQuit();

  static void sendMessage(int);
  static void sendRender();
private:

  static void initJoysticks();
  static void clearJoysticks();

  static void initAudio();
  static void playAudio(SoSDL_AudioSample&);

  static Uint32 mainTimerCB(Uint32,void*);

  //static void sensorQueueChanged(void*);
  //static Uint32 timerSensorCB(Uint32,void*);
  //static Uint32 delaySensorCB(Uint32,void*);

  static void dumpEvent(SDL_Event& aEvent);
private:
  static SDL_Surface* fScreen;
  static SoSDL_Widget* fWidget;
  static std::vector<SoSDL_AudioSample*>* fAudioSamples;  
  static SDL_TimerID fMainTimerID;
  //static SDL_TimerID fTimerSensorID;
  //static SDL_TimerID fDelaySensorID;
  static std::vector<SDL_Joystick*>* fJoySticks;
  static SbBool fViewer_render;
  static SbBool fToQuit;
};

#define SoSDL_USEREVENT_RENDER                       1
#define SoSDL_USEREVENT_PROCESS_DELAY_QUEUE_IDLE     2
#define SoSDL_USEREVENT_PROCESS_DELAY_QUEUE_NOT_IDLE 3
#define SoSDL_USEREVENT_PROCESS_TIMER_QUEUE          4

#endif
